import { IObject } from "@daybrush/utils";
import { RoleObject, OptionType, EventType, EasingFunction } from "./types";
export declare const PREFIX = "__SCENEJS_";
export declare const DATA_SCENE_ID = "data-scene-id";
export declare const TIMING_FUNCTION = "animation-timing-function";
export declare const ROLES: RoleObject;
export declare const ALIAS: IObject<string[]>;
export declare const FIXED: {
    "animation-timing-function": boolean;
    contents: boolean;
    html: boolean;
};
export declare const MAXIMUM = 1000000;
export declare const THRESHOLD = 0.000001;
export declare const DURATION = "duration";
export declare const FILL_MODE = "fillMode";
export declare const DIRECTION = "direction";
export declare const ITERATION_COUNT = "iterationCount";
export declare const DELAY = "delay";
export declare const EASING = "easing";
export declare const PLAY_SPEED = "playSpeed";
export declare const EASING_NAME = "easingName";
export declare const ITERATION_TIME = "iterationTime";
export declare const PAUSED = "paused";
export declare const ENDED = "ended";
export declare const TIMEUPDATE = "timeupdate";
export declare const ANIMATE = "animate";
export declare const PLAY = "play";
export declare const RUNNING = "running";
export declare const ITERATION = "iteration";
export declare const START_ANIMATION = "startAnimation";
export declare const PAUSE_ANIMATION = "pauseAnimation";
export declare const ALTERNATE = "alternate";
export declare const REVERSE = "reverse";
export declare const ALTERNATE_REVERSE = "alternate-reverse";
export declare const NORMAL = "normal";
export declare const INFINITE = "infinite";
export declare const PLAY_STATE = "playState";
export declare const PLAY_CSS = "playCSS";
export declare const PREV_TIME = "prevTime";
export declare const TICK_TIME = "tickTime";
export declare const CURRENT_TIME = "currentTime";
export declare const SELECTOR = "selector";
export declare const TRANSFORM_NAME = "transform";
export declare const EASINGS: {
    linear: EasingFunction;
    ease: EasingFunction;
    "ease-in": EasingFunction;
    "ease-out": EasingFunction;
    "ease-in-out": EasingFunction;
    "step-start": EasingFunction;
    "step-end": EasingFunction;
};
export declare const NAME_SEPARATOR = "_///_";
/**
* option name list
* @name Scene.OPTIONS
* @memberof Scene
* @static
* @type {$ts:OptionType}
* @example
* Scene.OPTIONS // ["duration", "fillMode", "direction", "iterationCount", "delay", "easing", "playSpeed"]
*/
export declare const OPTIONS: OptionType;
/**
* Event name list
* @name Scene.EVENTS
* @memberof Scene
* @static
* @type {$ts:EventType}
* @example
* Scene.EVENTS // ["paused", "ended", "timeupdate", "animate", "play", "iteration"];
*/
export declare const EVENTS: EventType;
